Index: /trunk/doc/manual/fr_FR/user_Introduction.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Introduction.xml	(revision 48222)
+++ /trunk/doc/manual/fr_FR/user_Introduction.xml	(revision 48223)
@@ -494,21 +494,20 @@
           </footnote>). Cela inclut entre autres&#xA0;:<itemizedlist>
             <listitem>
-              <para>8.04 ("Hardy Heron"),
-              8.10 ("Intrepid Ibex"), 9.04 ("Jaunty Jackalope"), 9.10 ("Karmic
-              Koala"), 10.04 ("Lucid Lynx"), 10.10 ("Maverick Meerkat),
+              <para>10.04 ("Lucid Lynx"), 10.10 ("Maverick Meerkat),
               11.04 ("Natty Narwhal"), 11.10 ("Oneiric Oncelot"),
-              12.04 ("Precise Pangolin")</para>
-            </listitem>
-
-            <listitem>
-              <para>Debian GNU/Linux 5.0 ("lenny") et 6.0 ("squeeze")</para>
-            </listitem>
-
-            <listitem>
-              <para>Oracle Enterprise Linux 4 et 5, Oracle Linux 6</para>
-            </listitem>
-
-            <listitem>
-              <para>Redhat Enterprise Linux 4, 5 et 6</para>
+              12.04 ("Precise Pangolin"), 12.10 ("Quantal Quetzal"),
+              13.04 ("Raring Ringtail")</para>
+            </listitem>
+
+            <listitem>
+              <para>Debian GNU/Linux 6.0 ("squeeze") et 7.0 ("wheezy")</para>
+            </listitem>
+
+            <listitem>
+              <para>Oracle Enterprise Linux 5, Oracle Linux 6</para>
+            </listitem>
+
+            <listitem>
+              <para>Redhat Enterprise Linux 5 and 6</para>
             </listitem>
 
Index: /trunk/doc/manual/fr_FR/user_Networking.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Networking.xml	(revision 48222)
+++ /trunk/doc/manual/fr_FR/user_Networking.xml	(revision 48223)
@@ -410,6 +410,59 @@
   </sect1>
 
+  <sect1 id="network_nat_service">
+    <title>Network Address Translation Service (expérimental)</title>
+    
+    <para>Le service Network Address Translation (NAT) fonctionne comme un
+    routeur domestique en regroupant les systèmes qui l'utilisent dans un réseau 
+    et en écartant les systèmes extérieurs d'accéder aux systèmes en son sein
+    tout en permettant aux systèmes qu'il contient de communiquer entre eux et
+    avec l'extérieur via TCP et UDP en IPv4 et IPv6.</para>
+
+    <para>Un service NAT est rattaché à un réseau interne. Les machines virtuelles
+    qui doivent l'utiliser devraient être branchées au réseau interne. Le nom du
+    réseau interne se choisit à la création du service NAT et le réseau interne
+    sera créé s'il n'existe pas déjà. Voici un exemple de commande pour créer
+    un réseau NAT :
+    </para>
+    <para><screen>VBoxManage natnetwork add -t nat-int-network -n "192.168.15.0/24" -e</screen></para>
+    <para>
+    Ici, "nat-int-network" est le nom du réseau interne à utiliser et
+    "192.168.15.0/24" est l'adresse du réseau et l'interface due masque du service NAT.
+    Dans cette configuration statique, par défaut, l'adresse affectée à la passerelle sera
+    192.168.15.1 (adresse suivant celle de l'interface), bien que cela soit sujet
+    à changement. Pour connecter un serveur DHCP au réseau interne, nous
+    modifions l'exemple comme suit :</para>
+    <para><screen>VBoxManage natnetwork add -t nat-int-network -n "192.168.15.0/24" -e -h on</screen></para>
+    <para> ou pour ajouter un serveur DHCP au réseau après l'avoir créé :</para>
+    <para><screen>VBoxManage natnetwork modify -t nat-int-network -h on</screen></para>
+    <para>Pour le désactiver à nouveau, utilisez :</para>
+    <para><screen>VBoxManage natnetwork modify -t nat-int-network -h off</screen></para>
+    <para>Une limite actuellement du serveur DHCP est qu'il ne fournit pas d'informations
+    nameserver, les szstèmes qui l'utilisent devraient donc être configurés explicitement
+    pour utiliser les bons serveurs de DNS.</para>
+    <para>Pour démarrer le service NAT, utilisez la commande suivante :</para>
+    <para><screen>VBoxManage natnetwork start -t nat-int-network</screen></para>
+    <para>Si un serveur DHCP est connecté au réseau, il démarrera avec le
+    service réseau NAT.</para>
+    <para><screen>VBoxManage natnetwork stop -t nat-int-network</screen> arrête
+    le service réseau NAT ainsi que le serveur DHCP s'il y en a un.</para>
+    <para>Pour effacer le service réseau NAT, utilisez :</para>
+    <para><screen>VBoxManage natnetwork remove -t nat-int-network</screen></para>
+    <para>Cette commande ne supprime pas le serveur DHCP s'il y en a un actif
+    sur le réseau interne.</para>
+    <para>La redirection de Ports est supportée (en utilisant le paramètre "-p"
+    pour 
+ switch for IPv4 et "-P" pour IPv6) :</para>
+    <para><screen>VBoxManage natnetwork modify -t nat-int-network -p "ssh:tcp:[]:10022:[192.168.15.15]:22"</screen></para>
+    <para>Ceci ajoute une règle de redirection de pots depuis le 10022 TCP de
+    l'hôte vers le 22 de l'invité ayant l'adresse IP 192.168.15.15.  Pour
+     effacer la règle, utilisez :</para>
+    <para><screen>VBoxManage natnetwork modify -t nat-int-network -p delete ssh</screen></para>
+    <para>Pour voir la liste des réseaux NAT enregistrés, utilisez :</para>
+    <para><screen>VBoxManage list natnetworks</screen></para>
+  </sect1>
+
   <sect1 id="network_bridged">
-    <title>Réseau Bridged</title>
+    <title>Réseau Bridgé</title>
 
     <para>Avec le réseau bridgé, VirtualBox utilise un pilote de périphérique 
Index: /trunk/doc/manual/fr_FR/user_VBoxManage.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 48222)
+++ /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 48223)
@@ -329,5 +329,4 @@
 Time offset:     0 ms
 Hardw. virt.ext: on
-Hardw. virt.ext exclusive: on
 Nested Paging:   on
 VT-x VPID:       off
@@ -588,14 +587,4 @@
             virtualisation (Intel VT-x ou AMD-V) dans le processeur de votre système
             hôte&#xA0;; voir <xref linkend="hwvirt" />.</para>
-          </listitem>
-
-          <listitem>
-            <para><computeroutput>--hwvirtexexcl on|off</computeroutput>&#xA0;:
-            Ceci spécifie si VirtualBox utilisera exclusivement les extensions de
-            virtualisation matérielle (Intel VT-x ou AMD-V) dans le processeur de
-            votre système hôte&#xA0;; voir <xref linkend="hwvirt" />. Si vous
-            souhaitez partager en même temps ces extensions avec d'autres 
-            hyperviseurs, vous devez désactiver ce paramètre. Ceci a des implications
-            négatives en performance.</para>
           </listitem>
 
@@ -2514,4 +2503,16 @@
 
         <glossentry>
+          <glossterm><computeroutput>hwvirtexclusive</computeroutput></glossterm>
+          <para>Ceci spécife si VirtualBox utilisera en exclusivité les
+          extensions de virtualisation matérielle (Intel VT-x ou AMD-V) du
+          processeur du système hôte ; voir <xref linkend="hwvirt" />. Si
+          vous souhaitez partager ces extensions avec d'autres hyperviseurs en
+          fonction en même temps, vous devez désactiver ce paramètre.
+          Cela a des implications négatives en termes de performance.
+          </para>
+        </glossentry>
+
+
+        <glossentry>
           <glossterm><computeroutput>vrdeauthlibrary</computeroutput></glossterm>
 
@@ -3297,8 +3298,8 @@
           <para><emphasis role="bold"><computeroutput>list</computeroutput></emphasis>,
           qui présente plusieurs informations de contrôle de l'invité telles
-          que les sessions ouvertes dans l'invité et les processus de l'invité.</para>
+          que les sessions et les fichiers ouverts dans l'invité et les processus de l'invité.</para>
 
           <screen>VBoxManage guestcontrol &lt;uuid|nomvm&gt; list
-          &lt;all|sessions|processes&gt; [--verbose]</screen>
+          &lt;all|sessions|processes|files&gt; [--verbose]</screen>
 
           <para>où les paramètres signifient&nbsp;: <glosslist>
@@ -3311,9 +3312,9 @@
 
             <glossentry>
-              <glossterm><computeroutput>all|sessions|processes</computeroutput></glossterm>
+              <glossterm><computeroutput>all|sessions|processes|files</computeroutput></glossterm>
 
               <glossdef>
                 <para>présenter les sessions dans l'invité, les processus de
-                l'invité ou toutes les informations disponibles.</para>
+                l'invité, les fichiers dans l'invité ou toutes les informations disponibles.</para>
               </glossdef>
             </glossentry>
@@ -3625,4 +3626,30 @@
               </glossentry>
             </glosslist></para>
+        </listitem>
+
+        <listitem>
+          <para><emphasis role="bold"><computeroutput>watch</computeroutput></emphasis>,
+          qui affiche un contrôle de l'activité actuelle de l'invité.</para>
+
+          <screen>VBoxManage guestcontrol &lt;uuid|nomvm&gt; watch
+          [--verbose]</screen>
+
+          <para>où les paramètres signifient : <glosslist>
+            <glossentry>
+              <glossterm><computeroutput>uuid|nomvm</computeroutput></glossterm>
+
+              <glossdef>
+                <para>L'UUID ou le nom de la VM. Obligatoire.</para>
+              </glossdef>
+            </glossentry>
+
+            <glossentry>
+              <glossterm><computeroutput>--verbose</computeroutput></glossterm>
+
+              <glossdef>
+                <para>Dit à VBoxManage d'être plus verbeux.</para>
+              </glossdef>
+            </glossentry>
+          </glosslist></para>
         </listitem>
       </itemizedlist></para>